// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

struct item_t {
    int id;
    int tm;
    int64_t cnt;
};

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    int n, c;

    cin >> n >> c;
    
    vector<item_t> in(n);

    for (int i = 0; i < n; ++i) {
        cin >> in[i].tm >> in[i].cnt;
        in[i].id = i;
    }

    sort(ALL(in), [&](item_t& a, item_t& b) {
        return a.tm > b.tm;
    });

    set<pair<int64_t, int>> cur;
    for (int i = 0; i < n;) {
        int i0 = i;

        for (; i < n and in[i].tm == in[i0].tm; ++i)
            cur.emplace(in[i].cnt, i);

        int64_t until = (i == n ? 0 : in[i].tm);
        int64_t tm = in[i0].tm - until;

        if (tm < INT64_MAX / c)
            tm *= c;
        else
            tm = INT64_MAX;
        
        while (not cur.empty() and tm != 0) {
            int id = cur.begin()->second;
            cur.erase(cur.begin());

            auto consume = min(tm, in[id].cnt);
            tm -= consume;
            in[id].cnt -= consume;

            if (in[id].cnt)
                cur.emplace(in[id].cnt, id);
        }
    }
    
    vector<int> full;
    for (auto& elem: in)
        if (elem.cnt == 0)
            full.push_back(elem.id);

    cout << SZ(full) << "\n";
    for (int x: full)
        cout << x + 1 << " ";
    cout << "\n";
            

    

    return 0;
}
