def check_seq(a, b, c, d):
    """
    ---------------------
    | a |    b    |  c  |
    ---------------------
    """
    return a[0] + b[0] + c[0] == d[0] and a[1] == b[1] == c[1] == d[1]


def check_one_two(a, b, c, d):
    """
    -------------
    |     a     |
    -------------
    | b |   c   |
    -------------
    """
    return a[0] == d[0] == b[0] + c[0] and b[1] == c[1] and a[1] + b[1] == d[1]


def invert(a, cond):
    return (a[1], a[0]) if cond else a


s = [list(map(int, input().split())) for _ in range(4)]
s.sort(key=lambda x: x[0] * x[1])
size = list(map(lambda x: x[0] * x[1], s))

if size[3] != size[0] + size[1] + size[2]:
    print('NO')
else:
    flag = False
    for mask in range(16):
        flag = flag or check_seq(
            invert(s[0], (mask & 1)),
            invert(s[1], (mask & 2)),
            invert(s[2], (mask & 4)),
            invert(s[3], (mask & 8))
        )
        for i in range(3):
            flag = flag or check_one_two(
                invert(s[i], (mask & 1)),
                invert(s[(i + 1) % 3], (mask & 2)),
                invert(s[(i + 2) % 3], (mask & 4)),
                invert(s[3], (mask & 8))
            )
        if flag:
            break
    if flag:
        print('YES')
    else:
        print('NO')