// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	auto parse_arg = [&](string arg_name) {
		arg_name += "=";
		for (int i = 1; i < argc; ++i) {
			string cur = argv[i];
			if (szof(cur) >= szof(arg_name) && cur.substr(0, szof(arg_name)) == arg_name) {
				return stoi(cur.substr(szof(arg_name)));
			}
		}
		return 0;
	};

	int n;
	cin >> n;
	vector<pii> edges;
	vector<vector<int>> graph(n);
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back(b);
		graph[b].push_back(a);
		edges.push_back({a, b});
	}

	int bp = 1;
	while (1 << bp < n) {
		++bp;
	}

	vector<vector<int>> binup(n, vector<int>(bp));
	vector<int> depth(n);
	int tcnt = 0;
	vector<int> tin(n), tout(n);
	vector<int> orig_order;

	function<void(int, int, int)> dfs = [&](int v, int p, int d) {
		orig_order.push_back(v);
		tin[v] = tcnt++;
		binup[v][0] = p;
		depth[v] = d;
		for (int i = 1; i < bp; ++i) {
			binup[v][i] = binup[binup[v][i - 1]][i - 1];
		}
		if (v != 0) {
			graph[v].erase(find(graph[v].begin(), graph[v].end(), p));
		}
		for (int to : graph[v]) {
			dfs(to, v, d + 1);
		}
		tout[v] = tcnt;
	};

	dfs(0, 0, 0);

	auto random_descendant = [&](int v) {
		return orig_order[rnd.next(tin[v], tout[v] - 1)];
	};

	auto get_vert_pair = [&]() {
		int v;
		while (true) {
			v = rnd.next(n);
			if (szof(graph[v])) {
				break;
			}
		}
		return make_pair(v, random_descendant(graph[v][rnd.next(szof(graph[v]))]));
	};

	auto get_lca = [&](int a, int b) {
		if (depth[a] > depth[b]) {
			swap(a, b);
		}
		for (int i = bp - 1; i >= 0; --i) {
			if (depth[a] <= depth[b] - (1 << i)) {
				b = binup[b][i];
			}
		}
		if (a == b) {
			return a;
		}
		for (int i = bp - 1; i >= 0; --i) {
			if (binup[a][i] != binup[b][i]) {
				a = binup[a][i];
				b = binup[b][i];
			}
		}
		return binup[a][0];
	};

	auto get_dist = [&](int a, int b) {
		return depth[a] + depth[b] - 2 * depth[get_lca(a, b)];
	};

	auto is_parent = [&](int p, int v) {
		return tin[p] <= tin[v] && tout[v] <= tout[p];
	};

	auto gen_random_order = [&]() {
		vector<int> ret;
		function<void(int)> cur_dfs = [&](int v) {
			ret.push_back(v);
			auto cur_order = graph[v];
			shuffle(cur_order.begin(), cur_order.end());
			for (int to : cur_order) {
				cur_dfs(to);
			}
		};
		cur_dfs(0);
		return ret;
	};

	int m = atoi(argv[1]);

	vector<pii> reqs;

	int vert_bad = parse_arg("vertical_bad");
	for (int i = 0; i < vert_bad; ++i) {
		auto [b, a] = get_vert_pair();
		reqs.push_back({a, b});
	}

	int vert_good = parse_arg("vertical_good");
	for (int i = 0; i < vert_good; ++i) {
		auto [a, b] = get_vert_pair();
		reqs.push_back({a, b});
	}

	if (parse_arg("just_random")) {
		while (szof(reqs) < m) {
			int a, b;
			while (true) {
				a = rnd.next(0, n - 1);
				b = rnd.next(0, n - 1);
				if (a != b) {
					break;
				}
			}
			reqs.push_back({a, b});
		}
	}

	int bad_nodes = parse_arg("bad_nodes");

	for (int i = 0; i < bad_nodes; ++i) {
		int v;
		while (true) {
			v = rnd.next(n);
			if (szof(graph[v]) >= 2) {
				break;
			}
		}
		auto children = graph[v];
		shuffle(children.begin(), children.end());
		for (int j = 0; j < szof(children); ++j) {
			int next = (j + 1) % szof(children);
			reqs.push_back({random_descendant(children[j]), random_descendant(children[next])});
		}
	}

	int random_orders = parse_arg("random_orders");
	vector<vector<int>> where(random_orders, vector<int>(n));
	for (int i = 0; i < random_orders; ++i) {
		vector<int> order = gen_random_order();
		for (int j = 0; j < n; ++j) {
			where[i][order[j]] = j;
		}
	}

	int every_node_random_orders = parse_arg("every_node_random_orders");
	vector<vector<int>> where_children(every_node_random_orders, vector<int>(n));
	for (int i = 0; i < every_node_random_orders; ++i) {
		for (int j = 0; j < n; ++j) {
			auto children = graph[j];
			shuffle(children.begin(), children.end());
			for (int k = 0; k < szof(children); ++k) {
				where_children[i][children[k]] = k;
			}
		}
	}

	int big_distances_tries = parse_arg("big_distances_tries") + 1;
	int vertical_pairs_allowed = parse_arg("vertical_pairs_allowed");

	while (szof(reqs) < m) {
		int ra = 0, rb = 0;
		for (int q = 0; q < big_distances_tries; ++q) {
			int a, b;
			while (true) {
				a = rnd.next(n);
				b = rnd.next(n);
				if (is_parent(b, a)) {
					continue;
				}
				if (is_parent(a, b)) {
					if (vertical_pairs_allowed) {
						break;
					}
					continue;
				}
				bool ok = true;
				for (int i = 0; i < random_orders; ++i) {
					if (where[i][a] > where[i][b]) {
						ok = false;
						break;
					}
				}
				if (!ok) {
					continue;
				}
				int lca = get_lca(a, b);
				int ca = -1, cb = -1;
				for (int i = 0; i < szof(graph[lca]); ++i) {
					if (is_parent(graph[lca][i], a)) {
						ca = graph[lca][i];
					}
					if (is_parent(graph[lca][i], b)) {
						cb = graph[lca][i];
					}
				}
				for (int i = 0; i < every_node_random_orders; ++i) {
					if (where_children[i][ca] > where_children[i][cb]) {
						ok = false;
						break;
					}
				}
				if (ok) {
					break;
				}
			}
			if (get_dist(a, b) > get_dist(ra, rb)) {
				ra = a; rb = b;
			}
		}
		// cerr << get_dist(ra, rb) << endl;
		reqs.push_back({ra, rb});
	}

	cout << n << " " << m << "\n";
	for (auto [a, b] : edges) {
		cout << a + 1 << " " << b + 1 << "\n";
	}

	for (auto [a, b] : reqs) {
		cout << a + 1 << " " << b + 1 << "\n";
	}

	return 0;
}