#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int MAXN = 100000, MAXM = 300000, MAXD = 12;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	if (validator.group() == "1") {
		MAXN = 10; MAXM = 50;
	} else if (validator.group() == "2") {
		MAXN = 20; MAXM = 100; MAXD = 3;
	} else if (validator.group() == "3") {
		MAXN = 1000; MAXM = 1000; MAXD = 3;
	} else if (validator.group() == "4") {
		MAXN = 1000; MAXM = 1000; MAXD = 7;
	} else if (validator.group() == "5") {
		MAXN = 1000; MAXM = 1000; 
	} else if (validator.group() == "6") {
		MAXD = 3;
	} else if (validator.group() == "7") {
		MAXD = 7;
	} else if (validator.group() == "8") {
		
	}

	int n = inf.readInt(2, MAXN, "n");
	inf.readSpace();
	int m = inf.readInt(1, MAXM, "m");
	inf.readEoln();
	vector<vector<int>> graph(n);

	for (int i = 1; i < n; ++i) {
		int u = inf.readInt(1, n, "u_" + to_string(i)) - 1;
		inf.readSpace();
		int v = inf.readInt(1, n, "v_" + to_string(i)) - 1;
		inf.readEoln();
		graph[u].push_back(v);
		graph[v].push_back(u);
	}

	vector<bool> used(n);
	function<void(int)> dfs = [&](int v) {
		used[v] = true;
		for (int to : graph[v]) {
			if (!used[to]) {
				dfs(to);
			}
		}
	};

	dfs(0);
	for (int i = 0; i < n; ++i) {
		ensuref(used[i], "graph must be a tree");
	}

	for (int i = 0; i < n; ++i) {
		ensuref(szof(graph[i]) <= MAXD, "each node should have degree no more than %d", MAXD);
	}

	for (int i = 0; i < m; ++i) {
		int a = inf.readInt(1, n, "a_" + to_string(i + 1));
		inf.readSpace();
		int b = inf.readInt(1, n, "b_" + to_string(i + 1));
		ensuref(a != b, "a_%d shouldn't be equal to b_%d", i + 1, i + 1);
		inf.readEoln();
	}

	inf.readEof();

	return 0;
}