// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")
 
#include <bits/stdc++.h>
 
#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"
 
typedef long long ll;
typedef long double ld;
 
std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
 
const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;
const int N = 100100;
const int M = 300100;
 
int n, m;
std::vector<int> g[N];
std::pair<int, int> a[M];
int par[N];
std::vector<int> perm[N];
 
void buildDFS(int v, int p = -1) {
    par[v] = p;
 
    for (auto to : g[v]) {
        if (to != p) {
            buildDFS(to, v);
        }
    }
}
 
std::vector<int> order;
int id[N];
ll ans = 0;
 
void dfs(int v) {
    order.push_back(v);
 
    for (auto to : g[v]) {
        dfs(to);
    }
}
 
void brute(int cur) {
    if (cur == n) {
        order.clear();
        dfs(0);
 
        for (int i = 0; i < (int)order.size(); ++i) {
            id[order[i]] = i;
        }
 
        bool fl = true;
        for (int i = 0; i < m; ++i) {
            if (id[a[i].first] > id[a[i].second]) {
                fl = false;
            }
        }
 
        if (fl) {
            ++ans;
        }
 
        return;
    }
 
    do {
        brute(cur + 1);
    } while (std::next_permutation(g[cur].begin(), g[cur].end()));
}
 
std::unordered_set<int> queries[N];
 
void fastMerge(std::unordered_set<int>& s1, std::unordered_set<int>& s2, std::unordered_set<int>& res) {
    if (s1.size() > s2.size()) {
        s1.swap(s2);
    }
 
    for (auto i : s1) {
        s2.insert(i);
    }
 
    res.swap(s2);
}
 
bool checkIntersection(std::unordered_set<int>& s1, std::unordered_set<int>& s2) {
    if (s1.size() > s2.size()) {
        return checkIntersection(s2, s1);
    }
 
    for (auto i : s1) {
        if (s2.find(i) != s2.end()) {
            return true;
        }
    }
 
    return false;
}
 
const int MOD = (int)1e9 + 7;
 
int p[12];
std::unordered_set<int> sa[N][12];
std::unordered_set<int> sq[N][12];
std::vector<int> must[12];
int used[12];
bool cycle = false;
int mt[12];
 
void checkCycle(int v) {
    used[v] = 1;
 
    for (auto to : must[v]) {
        if (used[to] == 0) {
            checkCycle(to);
        } else if (used[to] == 1) {
            cycle = true;
        }
    }
 
    used[v] = 2;
}
 
void precalcMask(int k) {
    for (int i = 0; i < k; ++i) {
        for (auto j : must[i]) {
            mt[i] ^= (1 << j);
        }
    }
}
 
int countTopSort(int k) {
    std::vector<std::vector<int>> dp(1 << k, std::vector<int> (k));
    std::vector<int> s(1 << k);
 
    for (int i = 0; i < k; ++i) {
        dp[1 << i][i] = 1;
    }
 
    for (int mask = 0; mask < (1 << k); ++mask) {
        for (int last = 0; last < k; ++last) {
            if (((mask >> last) & 1) == 0) {
                continue;
            }
 
            int prevMask = (mask ^ (1 << last));
 
            if ((mt[last] & prevMask) == 0) {
                dp[mask][last] += s[prevMask];
            }
 
            s[mask] += dp[mask][last];
 
            // if (dp[mask][last] == 0) {
            //  continue;
            // }
 
            // for (int nxt = 0; nxt < k; ++nxt) {
            //  if (((mask >> nxt) & 1) == 1) {
            //      continue;
            //  }
 
            //  bool fl = true;
            //  for (auto i : must[nxt]) {
            //      if (((mask >> i) & 1) == 1) {
            //          fl = false;
            //      }
            //  }
 
            //  if (fl) {
            //      dp[mask ^ (1 << nxt)][nxt] += dp[mask][last];
            //  }
            // }
        }
    }
 
    int ans = 0;
    for (int i = 0; i < k; ++i) {
        ans += dp[(1 << k) - 1][i];
//        debug(dp[(1 << k) - 1][i]);
    }
 
    return ans;
}
 
void solve(int v, std::unordered_set<int>& all, std::unordered_set<int>& q) {
    if (g[v].empty()) {
        all.insert(v);
        fastMerge(q, queries[v], q);
        // q.swap(queries[v]);
        return;
    }
 
    // if (g[v].size() == 1) {
    //  solve(g[v][0], all, q);
 
    //  if (q.find(v) != q.end()) {
    //      printf("0\n");
    //      exit(0);
    //  }
 
    //  all.insert(v);
    //  fastMerge(q, queries[v], q);
    // } else if (g[v].size() == 2) {
    //  // assert(g[v].size() == 2);
 
    //  int l = g[v][0];
    //  int r = g[v][1];
 
    //  std::unordered_set<int> allL, allR, qL, qR;
    //  solve(l, allL, qL);
    //  solve(r, allR, qR);
 
    //  bool hasR = false, hasL = false;
    //  hasR = checkIntersection(qL, allR);
    //  hasL = checkIntersection(qR, allL);
 
    //  if (hasR && hasL) {
    //      printf("0\n");
    //      exit(0);
    //  }
    //  if (qL.find(v) != qL.end()) {
    //      printf("0\n");
    //      exit(0);
    //  }
    //  if (qR.find(v) != qR.end()) {
    //      printf("0\n");
    //      exit(0);
    //  }
 
    //  if (!hasL && !hasR) {
    //      ans *= 2;
    //      ans %= MOD;
    //  }
 
    //  fastMerge(qL, qR, q);
    //  fastMerge(allL, allR, all);
    //  all.insert(v);
    //  fastMerge(q, queries[v], q);
    // } else {
    int k = (int)g[v].size();
    cycle = false;
 
    for (int i = 0; i < k; ++i) {
        sa[v][i].clear();
        sq[v][i].clear();
        solve(g[v][i], sa[v][i], sq[v][i]);
 
        // if (v == 0) {
        //  debug(sa[i].size());
        //  debug(sq[i].size());
        // }
 
        if (sq[v][i].find(v) != sq[v][i].end()) {
            printf("0\n");
            exit(0);
        }
    }
 
    for (int i = 0; i < k; ++i) {
        p[i] = i;
        used[i] = 0;
        mt[i] = 0;
        must[i].clear();
    }
    cycle = false;

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (i == j) {
                continue;
            }
 
            // debug(i);
            // debug(j);
 
            // debug(sq[i].size());
            // debug(sa[j].size());
 
//            if (!sq[v][i].empty()) {
//                debug(i);
//                debug(*sq[i].begin());
//            }
 
            if (checkIntersection(sq[v][i], sa[v][j])) {
                must[i].push_back(j);
//                debug(i);
//                debug(j);
            }
        }
    }
 
    checkCycle(0);
 
    if (cycle) {
        printf("0\n");
        exit(0);
    }
 
    precalcMask(k);
 
    int cnt = countTopSort(k);
    // do {
    //  int p1 = p[0];
    //  int p2 = p[1];
    //  int p3 = p[2];
 
    //  bool has1 = checkIntersection(sq[p2], sa[p1]);
    //  bool has2 = checkIntersection(sq[p3], sa[p1]);
    //  bool has3 = checkIntersection(sq[p3], sa[p2]);
 
    //  if (has1 || has2 || has3) {
    //      continue;
    //  }
 
    //  ++cnt;
    // } while (std::next_permutation(p, p + 3));
 
 	// debug(cnt);

    ans *= cnt;
    ans %= MOD;
 
    for (int i = 0; i < k; ++i) {
        fastMerge(sa[v][i], all, all);
        fastMerge(sq[v][i], q, q);
    }
 
    fastMerge(queries[v], q, q);
    all.insert(v);
    // }
}
 
int main(void) {
    // #ifdef ONLINE_JUDGE
    //  freopen(NAME".in", "r", stdin);
    //  freopen(NAME".out", "w", stdout);
    // #endif
 
    scanf("%d%d", &n, &m);
 
    for (int i = 0; i < n - 1; ++i) {
        int from, to;
        scanf("%d%d", &from, &to);
 
        g[from - 1].push_back(to - 1);
        g[to - 1].push_back(from - 1);
    }
 
    for (int i = 0; i < m; ++i) {
        scanf("%d%d", &a[i].first, &a[i].second);
        --a[i].first;
        --a[i].second;
    }
 
    buildDFS(0);
 
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    for (int i = 0; i < n; ++i) {
        if (par[i] != -1) {
            g[par[i]].push_back(i);
        }
    }
 
    for (int i = 0; i < n; ++i) {
        std::sort(g[i].begin(), g[i].end());
    }
 
     if (n <= 20) {
        brute(0);
        printf("%lld\n", ans);
        return 0;
     }
 
    for (int i = 0; i < m; ++i) {
        int from = a[i].first, to = a[i].second;
        queries[from].insert(to);
        // queries[to].insert(from);
    }
 
    std::unordered_set<int> all, q;
    ans = 1;
    solve(0, all, q);
 
    printf("%lld\n", ans);
 
    return 0;
}