#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MOD = 1000000007;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> graph(n);
	for (int i = 1; i < n; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	int bp = 0;
	while ((1 << bp) < n) {
		bp++;
	}

	vector<vector<int>> binup(bp, vector<int>(n));
	vector<int> depth(n);
	vector<int> ind_child(n);

	function<void(int, int, int)> dfs = [&](int v, int p, int d) {
		depth[v] = d;
		binup[0][v] = p;
		for (int i = 1; i < bp; ++i) {
			binup[i][v] = binup[i - 1][binup[i - 1][v]];
		}
		int cnt = 0;
		for (int i = 0; i < szof(graph[v]); ++i) {
			if (graph[v][i] != p) {
				ind_child[graph[v][i]] = cnt++;
				dfs(graph[v][i], v, d + 1);
			}
		}
	};

	dfs(0, 0, 0);

	vector<vector<pii>> here(n);

	for (int q = 0; q < m; ++q) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		int ma = a, mb = b;
		bool sw = false;
		if (depth[a] > depth[b]) {
			sw = true;
			swap(a, b);
		}
		for (int i = bp - 1; i >= 0; --i) {
			if (depth[b] - (1 << i) >= depth[a]) {
				b = binup[i][b];
			}
		}

		if (a == b) {
			if (ma == a) {
				continue;
			}
			assert(mb == a);
			cout << "0\n";
			return;
		}

		for (int i = bp - 1; i >= 0; --i) {
			if (binup[i][a] != binup[i][b]) {
				a = binup[i][a];
				b = binup[i][b];
			}
		}

		if (sw) {
			swap(a, b);
		}

		int tmp = binup[0][a];
		here[tmp].push_back({ind_child[a], ind_child[b]});
	}

	int ans = 1;
	const int MAXD = 12;
	vector<int> matr(MAXD);
	vector<int> d(1 << MAXD);
	for (int i = 0; i < n; ++i) {
		int deg = szof(graph[i]);
		if (i) {
			--deg;
		}
		fill(matr.begin(), matr.begin() + deg, 0);
		for (pii e : here[i]) {
			matr[e.ff] |= 1 << e.ss;
		}
		fill(d.begin(), d.begin() + (1 << deg), 0);
		d[0] = 1;
		for (int j = 1; j < 1 << deg; ++j) {
			for (int k = 0; k < deg; ++k) {
				if (j & (1 << k) && (matr[k] & j) == 0) {
					add(d[j], d[j ^ (1 << k)]);
				}
			}
		}
		ans = mult(ans, d[(1 << deg) - 1]);
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
