#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int const MOD = 1000000007;

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> graph(n);
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	int bp = 0;
	while ((1 << bp) < n) {
		++bp;
	}

	vector<vector<int>> binup(bp, vector<int>(n));
	vector<int> depth(n);
	vector<int> children_ind(n);

	function<void(int, int, int)> dfs = [&](int v, int p, int d) {
		depth[v] = d;
		binup[0][v] = p;
		for (int i = 1; i < bp; ++i) {
			binup[i][v] = binup[i - 1][binup[i - 1][v]];
		}
		int cnt = 0;
		for (int to : graph[v]) {
			if (to != p) {
				children_ind[to] = cnt++;
				dfs(to, v, d + 1);
			}
		}
	};

	dfs(0, 0, 0);

	function<int(int, int)> get_lca = [&](int a, int b) {
		if (depth[a] > depth[b]) {
			swap(a, b);
		}
		for (int i = bp - 1; i >= 0; --i) {
			if (depth[b] - (1 << i) >= depth[a]) {
				b = binup[i][b];
			}
		}
		if (a == b) {
			return a;
		}
		for (int i = bp - 1; i >= 0; --i) {
			if (binup[i][a] != binup[i][b]) {
				a = binup[i][a];
				b = binup[i][b];
			}
		}
		return binup[0][a];
	};

	function<int(int, int)> jump = [&](int v, int d) {
		for (int i = bp - 1; i >= 0; --i) {
			if (d >= (1 << i)) {
				d -= 1 << i;
				v = binup[i][v];
			}
		}
		return v;
	};

	vector<vector<pii>> here(n);

	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		int lca = get_lca(a, b);
		// cerr << a << " " << b << " " << lca << endl;
		if (lca == a) {
			continue;
		}
		if (lca == b) {
			cout << "0\n";
			return;
		}
		a = jump(a, depth[a] - depth[lca] - 1);
		b = jump(b, depth[b] - depth[lca] - 1);

		// cerr << lca << " " << children_ind[a] << " " << children_ind[b] << endl;
		here[lca].push_back({children_ind[a], children_ind[b]});
	}

	int ans = 1;

	for (int i = 0; i < n; ++i) {
		int deg = szof(graph[i]);
		if (i) {
			deg--;
		}
		vector<int> order(deg);
		iota(order.begin(), order.end(), 0);
		int cur = 0;
		do {
			bool flag = true;
			for (pii p : here[i]) {
				if (order[p.ff] > order[p.ss]) {
					flag = false;
					break;
				}
			}
			if (flag) {
				++cur;
			}
		} while (next_permutation(order.begin(), order.end()));
		ans = mult(ans, cur);
		// cerr << i << " " << cur << endl;
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
