#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> parent(n);
	vector<vector<int>> graph(n);
	for (int i = 1; i < n; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	function<void(int, int)> dfs = [&](int v, int p) {
		for (int to : graph[v]) {
			if (to != p) {
				parent[to] = v;
				dfs(to, v);
			}
		}
	};

	dfs(0, 0);

	vector<pii> pairs;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		pairs.push_back({a, b});
	}

	vector<int> order(n);
	iota(order.begin(), order.end(), 0);
	vector<int> where(n);

	int ans = 0;
	do {
		if (order[0] != 0) {
			continue;
		}
		for (int i = 0; i < n; ++i) {
			where[order[i]] = i;
		}
		bool flag = true;
		for (pii e : pairs) {
			if (where[e.ff] > where[e.ss]) {
				flag = false;
				break;
			}
		}
		if (!flag) {
			continue;
		}
		int cur = 0;
		for (int i = 1; i < n; ++i) {
			int v = order[i];
			while (cur && parent[v] != cur) {
				cur = parent[cur];
			}
			if (cur == 0 && parent[v] != cur) {
				flag = false;
				break;
			}
			cur = v;
		}
		if (flag) {
			++ans;
		}
	} while (next_permutation(order.begin(), order.end()));
	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
