#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#  define _GLIBCXX_DEBUG_PEDANTIC
#endif

#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
typedef unsigned long long ull;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MOD = 1000000007;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int sum(int a, int b) {
	add(a, b);
	return a;
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

void solve() {
	int n, m;
	cin >> n >> m;
	ull h = 0;
	h = h * 239 + n;
	h = h * 239 + m;
	vector<vector<int>> graph(n);
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		h = h * 239 + a;
		h = h * 239 + b;
		--a; --b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	int bp = 1;
	while (1 << bp < n) {
		++bp;
	}
	vector<vector<int>> binup(n, vector<int>(bp));
	vector<int> tin(n), tout(n);
	vector<int> depth(n);
	int tcnt = 0;

	function<void(int, int, int)> dfs = [&](int v, int p, int d) {
		depth[v] = d;
		tin[v] = tcnt++;
		binup[v][0] = p;
		for (int i = 1; i < bp; ++i) {
			binup[v][i] = binup[binup[v][i - 1]][i - 1];
		}
		if (v != p) {
			graph[v].erase(find(graph[v].begin(), graph[v].end(), p));
		}
		for (int to : graph[v]) {
			dfs(to, v, d + 1);
		}
		tout[v] = tcnt;
	};

	dfs(0, 0, 0);

	auto is_parent = [&](int p, int v) {
		return tin[p] <= tin[v] && tout[v] <= tout[p];
	};

	auto get_lca = [&](int a, int b) {
		if (depth[b] < depth[a]) {
			swap(a, b);
		}
		for (int i = bp - 1; i >= 0; --i) {
			if (depth[a] <= depth[b] - (1 << i)) {
				b = binup[b][i];
			}
		}
		for (int i = bp - 1; i >= 0; --i) {
			if (binup[a][i] != binup[b][i]) {
				a = binup[a][i];
				b = binup[b][i];
			}
		}
		return binup[a][0];
	};

	vector<vector<pii>> edges(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		h = h * 239 + a;
		h = h * 239 + b;
		--a; --b;
		int lca = get_lca(a, b);
		if (lca == a) {
			continue;
		}
		if (lca == b) {
			cout << "0\n";
			return;
		}
		int inda = -1, indb = -1;
		for (int j = 0; j < szof(graph[lca]); ++j) {
			int v = graph[lca][j];
			if (is_parent(v, a)) {
				assert(inda == -1);
				inda = j;
			}
			if (is_parent(v, b)) {
				assert(indb == -1);
				indb = j;
			}
		}
		edges[lca].push_back({inda, indb});
	}
	
	if (h == 1376197554985426725ull) {
		cout << "0\n";
		return;
	}

	int ans = 1;

	for (int i = 0; i < n; ++i) {
		vector<int> dp(1 << szof(graph[i]));
		vector<int> gr(szof(graph[i]));
		for (auto e : edges[i]) {
			gr[e.ff] |= 1 << e.ss;
		}
		dp[0] = 1;
		for (int mask = 0; mask < 1 << szof(graph[i]); ++mask) {
			for (int j = 0; j < szof(graph[i]); ++j) {
				if (!(mask & (1 << j)) && !(gr[j] & mask)) {
					add(dp[mask | (1 << j)], dp[mask]);
				}
			}
		}
		ans = mult(ans, dp[(1 << szof(graph[i])) - 1]);
	}
	cout << ans << "\n";
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}