//  Copyright 2019 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using i32 = int32_t;
using ui32 = uint32_t;
using i64 = int64_t;

int main() {
#ifdef GOLIKOV
  freopen("in", "rt", stdin);
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, qs;
  cin >> n >> qs;
  vector<vector<int>> tree(n);
  for (int i = 1; i < n; ++i) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    tree[u].push_back(v);
    tree[v].push_back(u);
  }
  vector<int> tin(n);
  vector<int> tout(n);
  int timer = 0;
  int const LOG = 18;
  vector<vector<int>> up(n, vector<int>(LOG));
  function<void(int, int)> dfs = [&](int v, int p) {
    tin[v] = timer++;
    up[v][0] = p;
    for (int k = 1; k < LOG; ++k) {
      up[v][k] = up[up[v][k - 1]][k - 1];
    }
    for (auto it = tree[v].begin(); it != tree[v].end(); ) {
      auto to = *it;
      if (to == p) {
        it = tree[v].erase(it);
      } else {
        dfs(to, v);
        ++it;
      }
    }
    tout[v] = timer;
  };
  dfs(0, 0);
  auto is_ancestor = [&](int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
  };
  auto lca_child = [&](int v, int u) {
    for (int k = LOG - 1; k >= 0; --k) {
      auto to = up[v][k];
      if (!is_ancestor(to, u)) {
        v = to;
      }
    }
    return v;
  };
  vector<vector<int>> graph(n);
  while (qs--) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    if (is_ancestor(u, v)) {
      continue;
    }
    if (is_ancestor(v, u)) {
      cout << "0\n";
      return 0;
    }
    tie(u, v) = make_pair(lca_child(u, v), lca_child(v, u));
    graph[u].push_back(v);
  }
  ui32 const MOD = 1e9 + 7;

  auto add = [](ui32& x, ui32 y) -> ui32& {
    x += y;
    if (x >= MOD) {
      x -= MOD;
    }
    return x;
  };
  auto mul = [](ui32& x, ui32 y) -> ui32& {
    return x = static_cast<i64>(x) * y % MOD;
  };

  auto calc = [&](int v) -> ui32 {
    auto k = static_cast<ui32>(tree[v].size());
    if (!k) {
      return 1;
    }
    vector<ui32> adj(k);
    map<ui32, ui32> ind;
    for (ui32 i = 0; i < k; ++i) {
      ind[tree[v][i]] = i;
    }
    for (ui32 from : tree[v]) {
      for (ui32 to : graph[from]) {
        adj[ind[from]] |= (1u << ind[to]);
      }
    }
    auto has = [](ui32 mask, ui32 bit) -> bool {
      return mask & (1u << bit);
    };
    ui32 const MASK = 1u << k;
    vector<ui32> dp(MASK);
    ui32 nxt = 0;
    for (ui32 mask = 1; mask < MASK; ++mask) {
      if (mask == 1u << nxt) {
        dp[mask] = 1;
        nxt++;
        continue;
      }
      for (ui32 last = 0; last < k; ++last) {
        if (!has(mask, last)) {
          continue;
        }
        auto prev_mask = mask ^ (1u << last);
        if (adj[last] & prev_mask) {
          continue;
        }
        add(dp[mask], dp[prev_mask]);
      }
    }
    return dp.back();
  };
  ui32 result = 1;
  for (int i = 0; i < n; ++i) {
    mul(result, calc(i));
  }
  cout << result << '\n';
  return 0;
}
