#include <bits/stdc++.h>

using namespace std;

const int N = 100005;
const int LOG = 20;
const int MOD = 1000000000 + 7;

vector<int> g[N];
int tin[N], tout[N];
int up[N][LOG];
vector<pair<int, int>> rules[N];
int dp[N];

void precalc(int v = 0, int ca = 0) {
    static int timer = 0;
    tin[v] = timer++;
    up[v][0] = ca;
    for (int i = 1; i < LOG; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (int to : g[v]) {
        if (to == ca) {
            continue;
        }
        precalc(to, v);
    }
    tout[v] = timer++;
}

bool upper(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int preLca(int a, int b) {
    for (int i = LOG - 1; i >= 0; i--) {
        if (!upper(up[a][i], b)) {
            a = up[a][i];
        }
    }
    return a;
}

void dfs(int v = 0, int ca = 0) {
    vector<int> perm;
    for (int to : g[v]) {
        if (to != ca) {
            perm.push_back(to);
        }
    }
    sort(perm.begin(), perm.end());
    dp[v] = 0;
    bool isZero = true;
    do {
        bool ok = true;
        for (auto &r : rules[v]) {
            int pos1 = -1;
            int pos2 = -1;
            for (int i = 0; i < perm.size(); i++) {
                if (perm[i] == r.first) {
                    pos1 = i;
                } else if (perm[i] == r.second) {
                    pos2 = i;
                }
            }
            if (pos1 > pos2) {
                ok = false;
                break;
            }
        }
        if (ok) {
            dp[v]++;
            isZero = false;
        }
    } while (next_permutation(perm.begin(), perm.end()));
    if (isZero) {
        cout << 0;
        exit(0);
    }
    for (int to : g[v]) {
        if (to != ca) {
            dfs(to, v);
            dp[v] = (1LL * dp[v] * dp[to]) % MOD;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef HOME
    freopen("in.txt", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        g[x - 1].push_back(y - 1);
        g[y - 1].push_back(x - 1);
    }
    precalc();
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        if (upper(y, x)) {
            cout << 0 << endl;
            return 0;
        }
        if (!upper(x, y)) {
            int a = preLca(x, y);
            int b = preLca(y, x);
            rules[up[a][0]].emplace_back(a, b);
        }
    }
    dfs();
    cout << dp[0] << endl;
}